﻿using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.FilmCasting.AutoDie.Common
{
    public static class ERRNOs
    {
        static ERRNOs()
        {
            ERRNO_PLC_DISCONNECTED = new ERRNO() { Code = 65535, Descrption = "PLC连接断开" };

            #region 收卷
            ERRNO_NO_FAN = new ERRNO() { Code = 0, Descrption = "总开关没打开，不能加热" };
            ERRNO_OPEN_CIRCUIT = new ERRNO() { Code = 1, Descrption = "加热棒断路" };
            ERRNO_SHORT_CIRCUIT = new ERRNO() { Code = 2, Descrption = "加热控制板短路" };
            ERRNO_POWER_OFF = new ERRNO() { Code = 3, Descrption = "电源没开启或电流计损坏" };
            ERRNO_NO_VELOCITY = new ERRNO() { Code = 4, Descrption = "线速度=0,没生产" };
            #endregion
        }
        #region 报警类型
        /// <summary>
        /// PLC连接断开
        /// </summary>
        public static ERRNO ERRNO_PLC_DISCONNECTED;
        /// <summary>
        /// 1.风机没开，不能加热
        /// </summary>
        public static ERRNO ERRNO_NO_FAN;
        /// <summary>
        /// 2.有加热棒断路
        /// </summary>
        public static ERRNO ERRNO_OPEN_CIRCUIT;
        /// <summary>
        /// 3.加热控制板短路
        /// </summary>
        public static ERRNO ERRNO_SHORT_CIRCUIT;
        /// <summary>
        /// 电源没开启或电流计损坏
        /// </summary>
        public static ERRNO ERRNO_POWER_OFF;
        /// <summary>
        /// 线速度=0,没生产
        /// </summary>
        public static ERRNO ERRNO_NO_VELOCITY;

        #endregion


    }
}
