﻿using FLY.OBJComponents.Client;
using FLY.Weight.Client;
using FLY.Weight.IService;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Page_Screw.xaml 的交互逻辑
    /// </summary>
    public partial class PgHopper : Page
    {
        IWeightSystemService weightSystemService;


        List<SetPLCUpdatePlan> setPlan_items = new List<SetPLCUpdatePlan>();

        public PgHopper()
        {
            InitializeComponent();

        }

        [InjectionMethod]
        public void Init(IWeightSystemService weightSystemService)
        {
            this.weightSystemService = weightSystemService;
            root_grid.DataContext = weightSystemService;
            
            RebuildPlans();

            if (weightSystemService is WeightSystemServiceClient) {
                (weightSystemService as WeightSystemServiceClient).ResetItemsEvent += MWeighterCsService_ResetItemsEvent;
            }
        }

        private void MWeighterCsService_ResetItemsEvent()
        {
            RebuildPlans();
        }
        /// <summary>
        /// 由于数量改变，重新构造更新计划
        /// </summary>
        void RebuildPlans()
        {

            foreach (SetPLCUpdatePlan plan in setPlan_items)
                plan.Dispose();
            setPlan_items.Clear();


            for (int i = 0; i < weightSystemService.Items.Count(); i++)
            {
                string objname = $"{nameof(IWeightSystemService.Items)}[{i}]";
                setPlan_items.Add(new SetPLCUpdatePlan(
                    weightSystemService.PLCos,
                    objname,
                    new string[] {
                        nameof(Common.WeighterC.UnloadingTime),
                        nameof(Common.WeighterC.ZeroStableTime),
                        nameof(Common.WeighterC.FlowSwitchEnable),
                        nameof(Common.WeighterC.SampleTimeSet),
                        nameof(Common.WeighterC.WeightStableTime),
                        nameof(Common.WeighterC.MixingTimeSet),

                        nameof(Common.WeighterC.MixSet),
                        nameof(Common.WeighterC.ScrewMotorRatedFreq),
                        nameof(Common.WeighterC.MaterialLowLimitSet),
                        nameof(Common.WeighterC.AlarmDeviationSet),
                        nameof(Common.WeighterC.WeightCorrectFactor),
                        nameof(Common.WeighterC.LackErrorSet)
                    }));
            }
        }

        private void button_back_Click(object sender, RoutedEventArgs e)
        {

            NavigationService.GoBack();
        }

        private void button_apply_Click(object sender, RoutedEventArgs e)
        {

        }

        private void Page_Unloaded(object sender, RoutedEventArgs e)
        {
            foreach (var setPlan in setPlan_items)
            {
                setPlan.Dispose();
            }
        }
    }
}
