﻿using FLY.Weight.IService;
using MultiLayout;
using MultiLayout.UiModule;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Weight.UI.Client.UiModule
{
    /// <summary>
    /// MenuSelect.xaml 的交互逻辑
    /// </summary>
    public partial class MenuSetting : UserControl
    {
        IUnityContainer container;
        public MenuSetting()
        {
            InitializeComponent();
        }

        [InjectionMethod]
        public void Init(IUnityContainer container)
        {
            this.container = container;
        }


        private void btnMenuClick(object sender, RoutedEventArgs e)
        {
            var weightSystem = container.Resolve<IWeightSystemService>();

            string version = weightSystem.Version;

            if (version == "v4")
            {
                var p = container.Resolve<PgMenuV4>();
                FlyLayoutManager.NavigationService.Navigate(p);
            }
            else//v3 
            {
                PgMenu p = new PgMenu();
                container.BuildUp(p);
                FlyLayoutManager.NavigationService.Navigate(p);
            }
        }
    }

}
