﻿using FLY.Weight.IService;
using MultiLayout.UiModule;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using Unity;

namespace FLY.Weight.UI.Client.UiModule
{
    public class UiModule2_MainGraph : IUiModule2
    {
        /// <summary>
        /// 控件标题
        /// 它的值取决于culture
        /// </summary>
        public string Title => "称重.主界面";

        public ComponentType Type => ComponentType.Graph;

        public bool IsUnique => true;

        /// <summary>
        /// 控件
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetComponent(int id, IUnityContainer container)
        {
            var weightSystem = container.Resolve<IWeightSystemService>();

            weightSystem.VersionStringParse(out int version, out int itemStyle);

            switch (version) 
            {
                case 0:
                    {
                        if (itemStyle == 0)
                        {
                            return container.Resolve<MainGraphV0>();
                        }
                        else {
                            return container.Resolve<MainGraphV0_2>();
                        }
                    }break;
                case 4:
                    {
                        if (itemStyle == 0)
                        {
                            return container.Resolve<MainGraphV4>();
                        }
                        else
                        {
                            return container.Resolve<MainGraphV4_2>();
                        }
                    }
                    break;
                case 5:
                    {
                        if (itemStyle == 0)
                        {
                            return container.Resolve<MainGraphV5>();
                        }
                        else
                        {
                            return container.Resolve<MainGraphV5_2>();
                        }
                    }
                    break;
                case 6:
                    {
                        if (itemStyle == 0)
                        {
                            return container.Resolve<MainGraphV6>();
                        }
                        else
                        {
                            return container.Resolve<MainGraphV6_2>();
                        }
                    }
                    break;
                default:
                    {
                        if (itemStyle == 0)
                        {
                            return container.Resolve<MainGraphV3>();
                        }
                        else
                        {
                            return container.Resolve<MainGraphV3_2>();
                        }
                    }break;
            }
        }

        /// <summary>
        /// 控件缩略图，用于编辑界面时，大致看看
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetThumbnail()
        {
            return new System.Windows.Controls.Grid();
        }


        /// <summary>
        /// 给出全部控件ID, 控件自行删除没有的参数
        /// </summary>
        /// <param name="IDs"></param>
        public void MatchParam(int[] IDs)
        {
        }


    }
   
}
