﻿using FLY.OBJComponents.Client;
using FLY.Weight.IService;
using MultiLayout.UiModule;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Weight.UI.Client.UiModule
{
    /// <summary>
    /// UcThickness.xaml 的交互逻辑
    /// </summary>
    public partial class UcThickness : UserControl
    {

        IWeightSystemService weightSystemService;

        SetPLCUpdatePlan setPlan_accessory;

        public UcThickness()
        {
            InitializeComponent();
        }
        public void Init(IWeightSystemService weightSystemService)
        {
            this.weightSystemService = weightSystemService;
            this.DataContext = this.weightSystemService;
            string objname = nameof(IWeightSystemService.Accessory);
            setPlan_accessory = new SetPLCUpdatePlan(
                this.weightSystemService.PLCos,
                objname,
                new string[] {
                        nameof(Common.WeighterAccessory.TotalFilmWidth),
                        nameof(Common.WeighterAccessory.IsRimNoRecycle),
                        nameof(Common.WeighterAccessory.RimWidth),
                        nameof(Common.WeighterAccessory.ActFilmWidth),
                        nameof(Common.WeighterAccessory.SetThickness),
                        nameof(Common.WeighterAccessory.TargetVelocity),
                        nameof(Common.WeighterAccessory.CurrentVelocity)
                });
        }


        private void button_thickness_Click(object sender, RoutedEventArgs e)
        {
            WdThickness w = new WdThickness();
            if (weightSystemService.Items.Count() < 1)
                return;

            w.SetThickness = (int)weightSystemService.Accessory.SetThickness;
            w.FilmWidth = (int)weightSystemService.Accessory.TotalFilmWidth;
            w.RimWidth = (int)weightSystemService.Accessory.RimWidth;
            w.IsRimNoRecycle = weightSystemService.Accessory.IsRimNoRecycle;



            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);

            if (w.ShowDialog() == true)
            {
                weightSystemService.Accessory.SetThickness = w.SetThickness;
                weightSystemService.Accessory.TotalFilmWidth = w.FilmWidth;
                weightSystemService.Accessory.RimWidth = w.RimWidth;
                weightSystemService.Accessory.IsRimNoRecycle = w.IsRimNoRecycle;

                FLY.ControlLibrary.Window_Tip.Show("", "厚度参数设置成功", TimeSpan.FromSeconds(2));
            }
        }

    }
}
